// shows the effect of various bit operations
#include <stdio.h>

void print_binary(int x) {
  int size = (sizeof x) * 8;  // makes this machine-independent
  // 2's complement
  if (x<0) printf("1");
  else printf("0");
  int i;
  int mask = 1;
  for (i=1; i<size-1; i++)
    mask = mask << 1;
  for (i=1; i<size; i++) {
    if (x&mask) printf("1");
    else printf("0");
    mask = mask >> 1;
  }
}

int main() {
  int x,y;
  unsigned int z;
  printf("Enter 2 numbers\n");
  scanf("%d %d", &x, &y);
  z = x;
  printf("x in binary is ");
  print_binary(x);
  printf("\ny in binary is ");
  print_binary(y);
  printf("\n\nx & y        = ");
  print_binary(x&y);
  printf("\nx | y        = ");
  print_binary(x|y);
  printf("\nx ^ y        = ");
  print_binary(x^y);
  printf("\n\nx            = ");
  print_binary(x);
  printf("\n~x           = ");
  print_binary(~x);
  printf("\nx<<1         = ");
  print_binary(x << 1);
  printf("\nx<<2         = ");
  print_binary(x << 2);
  printf("\nx>>3         = ");
  print_binary(x>>3);
  printf("\n\nx in decimal     = %d\n", x);
  printf("~x in decimal    = %d\n", ~x);
  printf("x<<1 in decimal = %d\n", x<<1);
  printf("x<<2 in decimal = %d\n", x<<2);
  printf("x>>1 in decimal = %d\n", x>>1);
  printf("\n");
  printf("\nz            = ");
  print_binary(z);
  printf("\n~z           = ");
  print_binary(~z);
  printf("\nz<<1         = ");
  print_binary(z << 1);
  printf("\nz<<2         = ");
  print_binary(z << 2);
  printf("\nz>>3         = ");
  print_binary(z>>3);
  printf("\n\nz in decimal     = %u\n", z);
  printf("~z in decimal    = %u\n", ~z);
  printf("~z<<1 in decimal = %u\n", z<<1);
  printf("~z<<2 in decimal = %u\n", z<<2);
  printf("~z>>1 in decimal = %u\n", z>>1);
  printf("\n");
  return 0;
}
