#include <stdio.h>
#include <math.h>
#include "show-bytes.c"

unsigned int b2u(char *s) {
  unsigned int x=0;
  while (*s!='\0') {                            // while s not pointing to NULL
    if (*s!='1' && *s!='0') { s++; continue; }  //   skip non-digits
    x <<= 1;                                    //   shift left one bit
    if (*s=='1') { x++; }                       //   add this bit
    s++;                                        //   advance s
  }
  return x;
}
int main() {
  double v;
  float f;
  float *p, *q;
  unsigned int x, y;

  p = (float *) &x;
  q = (float *) &y;

  v = 0;
  printf("%le = ", v);
  show_bytes((byte_pointer) &v, sizeof v);
  printf("\n\n");

  v = HUGE_VAL;
  printf("%le = ", v);
  show_bytes((byte_pointer) &v, sizeof v);
  printf("\n\n");

  v = -HUGE_VAL;
  printf("%le = ", v);
  show_bytes((byte_pointer) &v, sizeof v);
  printf("\n\n");

  v = 15213;
  printf("%le = ", v);
  show_bytes((byte_pointer) &v, sizeof v);
  printf("\n\n");

  f = 15213;
  printf("%e = ", f);
  show_bytes((byte_pointer) &f, sizeof f);
  printf("\n\n");

  //x = b2u("111100001111");
  //printf("%u = ", x);
  //show_bytes((byte_pointer) &x, sizeof x);
  //printf("\n\n");

  // Pos and neg zero
  x = b2u("0 00000000 00000000000000000000000");
  printf("%e = (+0)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  y = b2u("1 00000000 00000000000000000000000");
  printf("%e = (-0)\n", *q);
  show_bytes((byte_pointer) q, sizeof (*q));
  printf("\n\n");
  printf("(0)==(-0)? %d", x==y);
  printf("\n\n");

  // Denormalized
  x = b2u("0 00000000 00000000000000000000001");
  printf("%e = (0+epsilon)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("0 00000000 11111111111111111111111");
  printf("%e = (largest denorm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  // Normalized
  x = b2u("0 00000001 00000000000000000000000");
  printf("%e = (smallest norm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("0 01111110 11111111111111111111111");
  printf("%e = (1-epsilon)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("0 01111111 00000000000000000000000");
  printf("%e = (1)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("0 11111110 11111111111111111111111");
  printf("%e = (largest norm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  // Specials
  x = b2u("0 11111111 00000000000000000000000");
  printf("%e = (+INFINTIY)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("0 11111111 00000000000000000010000");
  printf("%e = (NaN)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  // Denormalized
  x = b2u("1 00000000 00000000000000000000001");
  printf("%e = (0+epsilon)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("1 00000000 11111111111111111111111");
  printf("%e = (largest denorm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  // Normalized
  x = b2u("1 00000001 00000000000000000000000");
  printf("%e = (smallest norm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("1 01111110 11111111111111111111111");
  printf("%e = (1-epsilon)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("1 01111111 00000000000000000000000");
  printf("%e = (1)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("1 11111110 11111111111111111111111");
  printf("%e = (largest norm)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  // Specials
  x = b2u("1 11111111 00000000000000000000000");
  printf("%e = (-INFINTIY)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  x = b2u("1 11111111 00000001000000000000000");
  printf("%e = (NaN)\n", *p);
  show_bytes((byte_pointer) p, sizeof (*p));
  printf("\n\n");

  return 0;
}
